﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;

namespace XAxisLabels
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = Data.GetData(30, 1000,2000);

         
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            DateTime minDate = (DataContext as ObservableCollection<Data>).First().Date;
            DateTime maxDate = (DataContext as ObservableCollection<Data>).Last().Date;

            (xAxis as CategoryDateTimeXAxis).MinimumValue = minDate;
            (xAxis as CategoryDateTimeXAxis).MaximumValue = maxDate;
            (xAxis as CategoryDateTimeXAxis).Interval = new TimeSpan(30, 0, 0, 0, 0);
        }

        private void Grid_SizeChanged(object sender, SizeChangedEventArgs e)
        {

        }
    }

    public class Data : INotifyPropertyChanged
    {
        private int value;
        private DateTime label;

        public DateTime Date
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Date");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Date = DateTime.Now.AddDays(i * 7),
                    Value = r.Next(rangeStart, rangeEnd),
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
